class Chunker
  def initialize(s)
    @s = s
    @i = 0
  end

  def get(b)
    n = 0
    b.times{|_|
      n |= @s[@i / 8][@i % 8] << _
      @i += 1
    }
    n
  end

  def offset
    @i
  end
end

def bits(n)
  b = 0
  while n > 0
    b += 1
    n >>= 1
  end
  b
end

chunker = Chunker.new("\204\217\251\313\355\017\243\234\224\205\213Q\250k[\256x`$&\327\201e\351\331ef\0276\345Kk\316l\347\372\307\243\361-\333\031p?S\n\260\332$G\314\246\363\t%\271\242\276!\265j\275\212<%\345\n\371m\261\220B\0341KN\243\325X\230\257\333^\273\255p9{\316E\345k\262)X\371\247\022vEXh\370T\000")

dict = {
  0 => '0',
  1 => '1',
  2 => '2',
  3 => '3',
  4 => :clear,
  5 => :end,
}

o = ''

k = chunker.get(bits(dict.size))
puts "#{k}: #{dict[k]}"
#o += dict[k]
#w = dict[k]
w = ''

dict_size = 6

while true
  k = chunker.get(bits(dict_size))
  if dict[k]
    e = dict[k]
  elsif k == dict_size
    e = w + w[0,1]
  else
    p dict
    raise "invalid #{k} #{dict_size}"
  end

  if e == :end
    p e
    break
  end

  o += e

  puts "#{k}: #{e} dict[#{dict.size}]<=#{w + e[0,1]} out=#{o.size} off=#{chunker.offset} rate=#{100*o.size/chunker.offset}"

  if w[0]
    dict[dict_size] = w + e[0,1]
    dict_size += 1
  end
  w = e
end

o.scan(/.{35}/) do
  puts $&.gsub(/./, '\&\&')
end
